// Copyright (C) 2018 Avatao.com Innovative Learning Kft.
// All Rights Reserved. See LICENSE file for details.

import { Injectable } from '@angular/core';
import { WebSocketService } from './websocket.service';
import { ProcessLogCommand } from './processlog-command';
import { config } from '../config';
import { BehaviorSubject } from 'rxjs/BehaviorSubject';

@Injectable()
export class ProcessLogService {
  newLog = new BehaviorSubject<any>(config.console.defaultLogs);
  showLiveLogs = config.console.showLiveLogs;

  command_handlers = {
    'new_log': this.newLogHandler.bind(this)
  };

  constructor(private webSocketService: WebSocketService) {
    this.webSocketService.connect();
    this.webSocketService.observeKey<ProcessLogCommand>('processlog').subscribe(
      (event) => this.command_handlers[event.data.command](event.data)
    );
  }

  newLogHandler(data: ProcessLogCommand) {
    if (this.showLiveLogs) {
      this.newLog.next({
        stdout: data.stdout,
        stderr: data.stderr
      });
    }
  }
}
